/*
    QJpegRest - An interactive JPEG decoder, with restoration algorithms
    Copyright (C) 2007  Lluís Batlle i Rossell

    Please find the license in the provided LICENSE file.
*/
class Scaler;
class CoefsImage;
class FloatImage;
class ActionCreator;

class QCSKeepHF : public ImproveRawPlane
{
protected:
    float HFlevel;
    int latestCoefs;

private:
    /*! The initial floatplane, which will be projected */
    FloatPlane reference;
    /*! Where the result will be stored */
    FloatPlane *result;

    CoefsPlane DCTmin;
    CoefsPlane DCTmax;
    CoefsPlane DCTimage;

    unsigned int width_in_blocks;
    unsigned int height_in_blocks;

    Qtable qtable;

    CoefsPlane coefs;

    void set_DCT_constraint();
    void start_restoration();
    void project(FloatPlane &out);

    float getLevel(const float *cblockmin, const float *cblockmax) const;

public:
    QCSKeepHF();

	void prepare(const CoefsPlane *coefs,
            const FloatPlane *initial);
	FloatPlane * apply();
};

class QCSKeepHFCreator : public ActionCreator
{
    QCSKeepHFCreator();

public:
    static void init();

    ImproveRawPlane * createImproveRawPlane() const;
	bool isapplicable(const JPEGParameters &p);
};
